import { InstancedInterleavedBuffer, Material, Object3D, WebGLRenderer } from 'three';
import SpeckleLineMaterial from '../materials/SpeckleLineMaterial';
import { NodeRenderView } from '../tree/NodeRenderView';
import { Batch, BatchUpdateRange, GeometryType } from './Batch';
import { DrawGroup } from './InstancedMeshBatch';
export default class LineBatch implements Batch {
    id: string;
    subtreeId: string;
    renderViews: NodeRenderView[];
    private geometry;
    batchMaterial: SpeckleLineMaterial;
    private mesh;
    colorBuffer: InstancedInterleavedBuffer;
    private static readonly vector4Buffer;
    get bounds(): import("three").Box3;
    get drawCalls(): number;
    get minDrawCalls(): number;
    get triCount(): number;
    get vertCount(): number;
    constructor(id: string, subtreeId: string, renderViews: NodeRenderView[]);
    get renderObject(): Object3D;
    get geometryType(): GeometryType;
    get materials(): Material[];
    get groups(): DrawGroup[];
    getCount(): number;
    setBatchMaterial(material: SpeckleLineMaterial): void;
    onUpdate(deltaTime: number): void;
    onRender(renderer: WebGLRenderer): void;
    setVisibleRange(...ranges: BatchUpdateRange[]): void;
    getVisibleRange(): BatchUpdateRange;
    getOpaque(): BatchUpdateRange;
    getTransparent(): BatchUpdateRange;
    getStencil(): BatchUpdateRange;
    setBatchBuffers(...ranges: BatchUpdateRange[]): void;
    setDrawRanges(...ranges: BatchUpdateRange[]): void;
    resetDrawRanges(): void;
    buildBatch(): void;
    getRenderView(index: number): NodeRenderView;
    getMaterialAtIndex(index: number): Material;
    /** TODO: I wish we wouldn't clone the material here...  */
    getMaterial(rv: NodeRenderView): Material;
    private makeLineGeometry;
    private makeLineGeometryTriangle;
    private updateColorBuffer;
    purge(): void;
}
